comment %
+------------------------------ CODED BY --------------------------------- 
|    _______________       ____________        ________________
|   /_____    _____/\     /  ______   /\      /  ____  ____   /\
|   \___ /   / ____\/    /  /\____/  / /     /  / __/ / __/  / /
|       /   / /         /  / /   /  / /     /  / / / / / /  / /
|      /   / /         /  / /   /  / /     /  / / /_/ / /  / /
|     /   / /         /  /_/___/  / /     /  / /  \_\/ /  / /
|    /___/ /         /___________/ /     /__/ /       /__/ /
|    \___\/          \___________\/      \__\/   !TOM\__\/  
|
|  # ## ### INFO ### ## #
|
|  # Nom     : FPU SAMPLE
|
|  # Source  : ASM 32bits
|
|  # Date    : Mai 2006
|
|  # Site    : WWW.TOM-ART.FR.ST
|
|  # Mail    : TOM-ART@FR.ST
|
|  # Notes   : Quelques exemples de divers utilisations du FPU en assembleur
|              dans le domaine des dmos. Cube, cercle, rotation, calculs,...
|
|              
|               
+-------------------------------------------------------------------------
%

.486
.model          flat, stdcall  
option          casemap :none 

;Includes + Libs ; <***************************************************

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\dialogs.inc
include \masm32\include\winmm.inc
include \masm32\include\msimg32.inc


includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\lib\msimg32.lib

include \masm32\MACROS\MACROS.asm

;Protos ; <************************************************************

WinMain           PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CONST ; <*************************************************************

PictureW      equ 600
PictureH      equ 400

.DATA ; <**************************************************************



ClassName       db "Win32asm_class",0
DisplayName     db " FPU SAMPLE by  TOM  .:. Press any key for rotation .:.",0

MyRect      RECT <0,0,PictureW,PictureH>

noir            dd 0000000h

ptX             dd 0
ptY             dd 0

scale           REAL4 0.1
scale_add       REAL4 0.1


pt              dd 100,100

.DATA? ; <*************************************************************

hInstance       dd ?
hmainDC         dd ?                                        
hmainbmp        dd ? 
temp1           dd ?
temp2           dd ?
temp3           dd ?
.CODE ; <**************************************************************

start:



        invoke  GetModuleHandle, NULL
        mov     hInstance, eax

        xor edx,edx
        invoke  WinMain,hInstance,edx,edx,SW_SHOWDEFAULT
     
        invoke  ExitProcess,eax


; -------------------------------------------------------------------------
WinMain         PROC hInst :DWORD,hPrevInst :DWORD,CmdLine :DWORD,CmdShow :DWORD
; -------------------------------------------------------------------------

                LOCAL   wc   :WNDCLASSEX
                LOCAL   msg  :MSG
                LOCAL   hwnd :HWND

        mov     wc.cbSize,sizeof WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.cbClsExtra,NULL


        mov     wc.cbWndExtra,NULL      
        push    hInst
        pop     wc.hInstance

        mov     wc.hbrBackground,COLOR_BTNFACE+4
        
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset ClassName             
        mov     wc.hIcon,NULL
        invoke  LoadCursor,NULL,IDC_ARROW				
        mov     wc.hCursor,eax      
        mov     wc.hIconSm,NULL
        
        invoke  RegisterClassEx, ADDR wc


        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,PictureW/2
        push    eax

        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,PictureH/2
        pop     ebx

        invoke  CreateWindowEx,WS_EX_LEFT,ADDR ClassName,ADDR DisplayName,
                WS_OVERLAPPEDWINDOW,ebx,eax,PictureW,PictureH,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        push eax

        mov edi, hwnd
        invoke  ShowWindow,edi,SW_SHOWNORMAL
        invoke  UpdateWindow,edi

_Start:
        invoke  GetMessage,ADDR msg,NULL,0,0
        test    eax, eax
        jz      _Exit
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg

        jmp     _Start
_Exit:

        mov     eax,msg.wParam
        ret
; -------------------------------------------------------------------------
WinMain         ENDP
; -------------------------------------------------------------------------


; -------------------------------------------------------------------------
WndProc  PROC   uses edx ecx ebx esi edi  hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD
; -------------------------------------------------------------------------


	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT

mov eax, uMsg  

; -------------------------------------------------------------------------


    .IF eax == WM_PAINT 

invoke BeginPaint,hWnd, ADDR ps
mov    hdc,eax


; ------------------------------------------------------------- PIXEL

      xor esi,esi
      
      @SetPixel:
      
      call rotation2D

      invoke SetPixel, hmainDC, ptX, ptY, 0ffffffh
          
      add esi,8
      cmp esi, 1*8  ; 1 points
      jne @SetPixel

; ------------------------------------------------------------- PIXEL

invoke BitBlt, hdc, 0,0, PictureW,PictureH, hmainDC, 0, 0, SRCCOPY

invoke EndPaint,hWnd, ADDR ps

; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_KEYDOWN

  
invoke FillRect, hmainDC, addr MyRect,noir
invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE	

cmp wParam, VK_ESCAPE
je destroy

fld scale_add
fld scale
faddp st(1),st
fstp scale




; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_CREATE

invoke CreateSolidBrush,noir
mov noir,eax

;  main

  invoke GetDC, hWnd
  mov hdc, eax

  mov esi,PictureW
  mov edi,PictureH


  invoke CreateCompatibleDC, hdc
  mov dword ptr [hmainDC],eax

  invoke CreateCompatibleBitmap, hdc, esi, edi
  mov dword ptr [hmainbmp],eax

  invoke SelectObject, [hmainDC], eax
  
  invoke ReleaseDC,hWnd, hdc
;  main

    .ELSEIF eax == WM_CLOSE
destroy:
invoke PostQuitMessage,NULL
invoke DeleteDC, [hmainDC]

invoke DeleteObject, [hmainbmp]
invoke DeleteObject, noir
.ENDIF



        xor eax,eax
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret


rotation2D:

finit

fld scale
fsin
fild dword ptr [pt+esi+4] ;Y
fmul st(0),st(1)
fld scale
fcos
fild dword ptr [pt+esi] ;X
fmul st(0),st(1)
fsub st(0),st(2)
fistp dword ptr [ptX]


fld scale
fcos
fild dword ptr [pt+esi+4] ;Y
fmul st(0),st(1)
fld scale
fsin
fild dword ptr [pt+esi] ;X
fmul st(0),st(1)
fadd st(0),st(2)
fistp dword ptr [ptY]


add dword ptr [ptX],PictureW/2
add dword ptr [ptY],PictureH/2

retn
; -------------------------------------------------------------------------
WndProc         ENDP
; -------------------------------------------------------------------------




; -------------------------------------------------------------------------
END             start
; -------------------------------------------------------------------------

